
/* Petit programme pour mesurer la température du radiateur et indiquer
   sa valeur sur l'afficheur LCD dédié à ce petit projet. */

#include <LiquidCrystal.h>
#include <math.h>

//--------------------- Définition des broches d'E/S ------------------------
#define Pilotage_RETRO 13 // Pilotage du rétroéclairage.
#define Capteur_KY_013 3 // A3 affectée à la mesure de température.
LiquidCrystal MonEcran(8, 9, 4, 5, 6, 7);

//------------------------- Constantes logicielles --------------------------
byte degre[8] = {4,10,4,0,0,0,0,0}; // Caractère spécial "°".

//------------------------- variables du programme --------------------------
boolean Retro_ECL_actif = true;
int Mesure_NUM_CTN;
double Temperature;

 
void setup(){
  MonEcran.begin(16,2); pinMode(Pilotage_RETRO, OUTPUT);
  digitalWrite(Pilotage_RETRO, HIGH); // Allume le rétroéclairage.
  MonEcran.createChar(4,degre); // En position 4 car les trois premiers sont réservés pour
                                // créer le "é", le "y" et le "p". 
}
 
void loop() {
 int Mesure_NUM_CTN = analogRead(Capteur_KY_013);
 Temperature = Conversion_en_degres(Mesure_NUM_CTN);
 MonEcran.setCursor(0,0); MonEcran.print("Temp = ");
 MonEcran.print(Temperature,1); MonEcran.write(4); MonEcran.print("C  "); // Affiche la température.
 MonEcran.setCursor(0,1); MonEcran.print("CAN = ");
 MonEcran.print(Mesure_NUM_CTN); MonEcran.print("   ");  // Affiche la valeur numérisée.
 delay(500);}

double Conversion_en_degres(int Mesure_CTN) {
  double Tmp_Kelvin;
  Tmp_Kelvin = log(10000.0 * ((1024.0 / Mesure_CTN - 1))); 
  Tmp_Kelvin = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Tmp_Kelvin * Tmp_Kelvin ))* Tmp_Kelvin );
  Tmp_Kelvin = Tmp_Kelvin - 273.15; // Conversion des degrés Kelvin en degrés Celcius.
  return Tmp_Kelvin; }

